#pragma once
#include "d3dx9anim.h"
#include "Mesh.h"


/// t[
struct MYFRAME: public D3DXFRAME {
	D3DXMATRIX CombinedTransformationMatrix;
};


/// bVRei
struct MYMESHCONTAINER: public D3DXMESHCONTAINER {
	LPDIRECT3DTEXTURE9*  ppTextures;
	unsigned long maxFaceInfl;			// 1ʂ̃{[̍ő吔
	unsigned long numBoneCombination;	// {[Rrl[V̐
	LPD3DXBUFFER pBoneBuffer;			// {[Ee[u
	D3DXMATRIX** ppBoneMatrix;			// SẴ{[̃[hs̐擪|C^[
	D3DXMATRIX* pBoneOffsetMatrices;
};


/// t[`p֐Q
class FrameRendering {
private:
	virtual void RenderMeshContainer(LPDIRECT3DDEVICE9 pDevice, MYMESHCONTAINER* pMeshContainer, MYFRAME* pFrame);	/// bVReĩ_O
public:
	virtual void UpdateMatrices(LPD3DXFRAME pFrame, LPD3DXMATRIX world);	/// t[̃[hϊ
	virtual void Draw(LPDIRECT3DDEVICE9 pDevice, LPD3DXFRAME pFrame);		/// t[̃_O
};


/// Kw\֐Q
class MyHierarchy : public ID3DXAllocateHierarchy {
private:
	void CreateTexture(MYMESHCONTAINER* pMeshContainer, LPDIRECT3DDEVICE9 pDevice, DWORD NumMaterials);
	void SetDefaultMaterial(MYMESHCONTAINER* pMeshContainer);
public:
	STDMETHOD(CreateFrame)(THIS_ LPCSTR , LPD3DXFRAME *);
	STDMETHOD(CreateMeshContainer)(THIS_ LPCSTR, CONST D3DXMESHDATA*, CONST D3DXMATERIAL*, CONST D3DXEFFECTINSTANCE*, DWORD, CONST DWORD*, LPD3DXSKININFO, LPD3DXMESHCONTAINER*);
	STDMETHOD(DestroyFrame)(THIS_ LPD3DXFRAME);
	STDMETHOD(DestroyMeshContainer)(THIS_ LPD3DXMESHCONTAINER);
};


/// Aj[VbV
class AnimationMesh : public Drawable3D {
protected:
	LPDIRECT3DDEVICE9			pDevice;			// Direct3DfoCXIuWFNg
	LPD3DXFRAME					pFrameRoot;			// t[
	LPD3DXANIMATIONCONTROLLER	pAnimController;	// Aj[VRg[
	LPD3DXANIMATIONSET			pAnimSet[100];		// Aj[VZbg
	HRESULT AllocateBoneMatrix(LPD3DXMESHCONTAINER);// bVɍsU
	HRESULT AllocateAllBoneMatrices(LPD3DXFRAME);	// ċAR[hFt[KwWJĊebVɍsU
	void FreeAnim(LPD3DXFRAME pF);					// ċAR[hFSẴbVRei[X
	FrameRendering				frameOperator;		// t[`p֐Q
	MyHierarchy					myHierarchy;		// Kw\֐Q
	AnimationMesh(LPDIRECT3DDEVICE9 pDevice);		// IuWFNg֎~
public:
	virtual ~AnimationMesh();
	virtual void Draw(D3DXVECTOR3* position, D3DXMATRIX* rotation, D3DLIGHT9* light, Camera* camera);/// `
	virtual void AdvanceTime(double time);			/// Ԃis
	virtual void ChangeMotion(int motion_number);	/// ؂ւ
	virtual LPD3DXFRAME GetFrame();					/// t[擾
};


/// Xt@CǍ񂾃Aj[VbV
class XFileAnimationMesh sealed : public AnimationMesh {
public:
	XFileAnimationMesh(LPCTSTR filename, LPDIRECT3DDEVICE9 pDevice);
};
